Nexp = 10;

tic
for iExp=1:Nexp
  fprintf(' %d / %d (%g c)\n', iExp, Nexp, toc);

  bami

  iErr = 0;
  while (abs((xp(2, N) - xp0(2, N))/2/pi) > 0.1) | (abs(xt(1, N) - xt0(1, N)) > 1)
    iErr = iErr + 1;
    fprintf('  \n');
    bami
    if (iErr>10)  %  
      break
    end
  end

  fid = fopen('BamiStatPhasePhiS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatPhasePhiS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + mod(xp(1, :) - xp0(1, :)+pi/4, pi/2)-pi/4;
  for i=1:N
    fprintf(fid, '%g\n', Sum(i));
  end
  fclose(fid);

  fid = fopen('BamiStatPhasePhiS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatPhasePhiS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + (mod(xp(1, :) - xp0(1, :)+pi/4, pi/2)-pi/4).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

  figure(1); hold on; grid on
  plot(t, mod(xp(1, :) - xp0(1, :)+pi/4, pi/2)-pi/4, 'b')
  drawnow
  fid = fopen('BamiStatPhaseFS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatPhaseFS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + (xp(2, :) - xp0(2, :))/2/pi;
  for i=1:N
    fprintf(fid, '%g\n', Sum(i) );
  end
  fclose(fid);

  fid = fopen('BamiStatPhaseFS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatPhaseFS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + ((xp(2, :) - xp0(2, :))/2/pi).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

  fid = fopen('BamiStatTauTauS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatTauTauS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + xt(1, :) - xt0(1, :);
  for i=1:N
    fprintf(fid, '%g\n', Sum(i));
  end
  fclose(fid);

  fid = fopen('BamiStatTauTauS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatTauTauS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + (xt(1, :) - xt0(1, :)).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

  figure(2); hold on; grid on
  plot(t, xt(1, :) - xt0(1, :), 'b')
  drawnow
  fid = fopen('BamiStatTauVS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatTauVS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + xt(2, :) - xt0(2, :);
  for i=1:N
    fprintf(fid, '%g\n', Sum(i) );
  end
  fclose(fid);

  fid = fopen('BamiStatTauVS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatTauVS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + (xt(2, :) - xt0(2, :)).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

  fid = fopen('BamiStatInterpTauS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatInterpTauS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + xt(1, :) - xti(1, :);
  for i=1:N
    fprintf(fid, '%g\n', Sum(i));
  end
  fclose(fid);

  fid = fopen('BamiStatInterpTauS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatInterpTauS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + (xt(1, :) - xti(1, :)).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

  figure(3); hold on; grid on
  plot(t, xt(1, :) - xti(1, :), 'b')
  drawnow

  fid = fopen('BamiStatInterpVS.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum = zeros(1, N);
    else
      Sum = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatInterpVS.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum = Sum + xt(2, :) - xti(2, :);
  for i=1:N
    fprintf(fid, '%g\n', Sum(i) );
  end
  fclose(fid);

  fid = fopen('BamiStatInterpVS2.txt', 'r');
  if (fid == -1)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    NEXP = fscanf(fid, '%d\n', 1);
    if isempty(NEXP)
      NEXP = 0;
      Sum2 = zeros(1, N);
    else
      Sum2 = fscanf(fid, '%g\n', N)';
    end
    fclose(fid);
  end
  fid = fopen('BamiStatInterpVS2.txt', 'w');
  fprintf(fid, '%d\n', NEXP+1);
  Sum2 = Sum2 + (xt(2, :) - xti(2, :)).^2;
  for i=1:N
    fprintf(fid, '%g\n', Sum2(i));
  end
  fclose(fid);

end
fid = fopen('BamiStatPhasePhiS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatPhasePhiM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatPhasePhiS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatPhasePhiSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
fid = fopen('BamiStatPhaseFS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatPhaseFM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatPhaseFS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatPhaseFSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
fid = fopen('BamiStatTauTauS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatTauTauM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatTauTauS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatTauTauSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
fid = fopen('BamiStatTauVS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatTauVM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatTauVS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatTauVSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
fid = fopen('BamiStatInterpTauS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatInterpTauM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatInterpTauS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatInterpTauSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
fid = fopen('BamiStatInterpVS.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum = zeros(1, N);
  else
    Sum = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatInterpVM.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), Sum(i)/NEXP);
  end
  fclose(fid);
end

fid = fopen('BamiStatInterpVS2.txt', 'r');
if (fid == -1)
  NEXP = 0;
  Sum2 = zeros(1, N);
else
  NEXP = fscanf(fid, '%d\n', 1);
  if isempty(NEXP)
    NEXP = 0;
    Sum2 = zeros(1, N);
  else
    Sum2 = fscanf(fid, '%g\n', N)';
  end
  fclose(fid);
end

if NEXP > 0
  fid = fopen('BamiStatInterpVSgn.txt', 'w');
  for i=1:N
    fprintf(fid, '%g  %g\n', t(i), sqrt((Sum2(i)/NEXP - (Sum(i)/NEXP)^2)*NEXP/(NEXP-1)));
  end
  fclose(fid);
end
